/* remove the 'new' */
void grbs_detach_addr(grbs_t *grbs, grbs_detached_addr_t *dst, grbs_addr_t *addr)
{
	dst->type = addr->type;
	dst->user_data = addr->user_data;


	switch(addr->type & 0x0F) {
		case ADDR_ARC_CONVEX:
		case ADDR_ARC_CONCAVE:
			dst->pt = addr->obj.arc->parent_pt;
			dst->new_sa = addr->obj.arc->new_sa;
			dst->new_da = addr->obj.arc->new_da;
			dst->new_r = addr->obj.arc->new_r;
			dst->new_adir = addr->obj.arc->new_adir;
			dst->concave = addr->obj.arc->concave;

			if (!addr->obj.arc->in_use) {
				assert(addr->obj.arc->link_point.prev == NULL); /* this should be a sentinel */
				dst->arc = NULL;
			}
			else
				dst->arc = addr->obj.arc;
			


			addr->obj.arc->new_in_use = 0;
			if (grbs_clean_unused_sentinel_seg(grbs, addr->obj.arc->parent_pt, addr->obj.arc->concave, addr->obj.arc->segi))
				dst->arc = NULL; /* sentinel got removed */
			break;
		case ADDR_POINT:
			dst->arc = NULL;
			dst->pt = addr->obj.pt;
			break;
	}
}

grbs_addr_t *grbs_reattach_addr(grbs_t *grbs, grbs_detached_addr_t *src)
{
	grbs_addr_t *addr = grbs_addr_new(grbs, src->type, NULL);

	addr->user_data = src->user_data;

	switch(src->type & 0x0F) {
		case ADDR_ARC_CONVEX:
		case ADDR_ARC_CONCAVE:
			if (src->arc == NULL) {
				int segi;
				/* need to allocate a new sentinel */
				addr->obj.arc = grbs_new_sentinel(grbs, src->pt, src->new_sa, src->new_da, src->concave, &segi);
				addr->obj.arc->segi = segi;
			}
			else
				addr->obj.arc = src->arc;

			addr->obj.arc->new_r = src->new_r;
			addr->obj.arc->new_sa = src->new_sa;
			addr->obj.arc->new_da = src->new_da;
			addr->obj.arc->new_adir = src->new_adir;
			addr->obj.arc->new_in_use = 1;
			break;

		case ADDR_POINT:
			addr->obj.pt = src->pt;
			break;
	}

	return addr;
}
